{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "28b79368-d3fb-49ff-a742-8d399f417c07",
   "metadata": {},
   "source": [
    "# 3.2 Δημιουργία κλάσεων στο ΟΠΕ\n",
    "© Γιάννης Κωστάρας\n",
    "\n",
    "---\n",
    "\n",
    "[<](../3.1-OOP/3.1-OOP.ipynb) | [Δ](../../TOC.ipynb) | [>](../3.3-UML/3.3-UML.ipynb)\n",
    "\n",
    "---"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "43c83314-8568-44f7-95d4-277a29308840",
   "metadata": {},
   "source": [
    "### Μαθησιακοί στόχοι\n",
    "Σε αυτήν την ενότητα θα μάθουμε πώς μπορούμε να δημιουργήσουμε τις κλάσεις που μάθαμε στο προηγούμενο μάθημα:\n",
    "\n",
    "* σε έναν απλό κειμενογράφο\n",
    "* στο BlueJ\n",
    "* στο NetBeans\n",
    "* στο Visual Studio Code"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "3a8450cc-6648-44b2-96f9-a77fc529de93",
   "metadata": {},
   "source": [
    "## Κειμενογράφος\n",
    "\n",
    "Φυσικά μπορείτε να μη χρησιμοποιήσετε κάποιο ΟΠΕ για να μεταγλωττίσετε τις κλάσεις σας. Αλλά ας δούμε πρώτα πώς μπορούμε να δημιουργήσουμε τα προγράμματά μας χωρίς αυτό.\n",
    "\n",
    "Δημιουργήστε ένα νέο αρχείο στον αγαπημένο επεξεργαστή κειμένου, επικολλήστε τον κώδικα της κλάσης ```Car``` από το προηγούμενο μάθημα, και αποθηκεύστε το ως ```Car.java```. Θα πρέπει όμως να μπορούμε να δημιουργήσουμε και αντικείμενα της κλάσης αυτής και να δούμε τα αποτελέσματα στην οθόνη μας. Γι' αυτό το σκοπό χρειαζόμαστε μια μέθοδο ```main()``` όπως μάθαμε στα μαθήματα της προηγούμενης εβδομάδας. Μπορούμε είτε να προσθέσουμε την ```main()``` στην ```Car``` είτε να δημιουργήσουμε μια νέα κλάση, π.χ. ```CarDemo.java``` που να έχει μόνο τη μέθοδο ```main()```. Θα κάνουμε το πρώτο."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "c1b246d6-c600-4946-9615-d4574e5c5a0d",
   "metadata": {},
   "outputs": [],
   "source": [
    "class Car { // κλάση\n",
    "  // ιδιότητες/γνωρίσματα\n",
    "  String model;\n",
    "  int maxSpeed;\n",
    "  int ccm;\n",
    "  int speed = 0;\n",
    "  // μέθοδος δημιουργίας αντικειμένων - κατασκευαστής\n",
    "  Car(String m, int s, int c) {\n",
    "    model = m; maxSpeed = s; ccm = c;\n",
    "  }\n",
    "  // ενέργειες/μέθοδοι\n",
    "  void accelerate() {\n",
    "     if (speed <= maxSpeed - 10)\n",
    "        speed+=10;\n",
    "  }\n",
    "  void decelerate() {\n",
    "     if (speed >= 10)\n",
    "        speed-=10;\n",
    "  }\n",
    "  public String toString() {\n",
    "     return \"Car[\" + \"model=\" + model + \", maxSpeed=\" + maxSpeed + \", ccm=\" + ccm + \", speed=\" + speed + \"]\"; \n",
    "  }\n",
    "    \n",
    "  public static void main(String... args) {\n",
    "      Car audiA3 = new Car(\"Audi A3\", 210, 1595);\n",
    "      System.out.println(audiA3.speed);\n",
    "      audiA3.accelerate();\n",
    "      System.out.println(audiA3.speed);\n",
    "  }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "772fc711-1a9c-4870-9032-95e3d7c3096a",
   "metadata": {},
   "source": [
    "Μεταγλωττίστε το και εκτελέστε το όπως μάθατε στο μάθημα της προηγούμενης εβδομάδας.\n",
    "\n",
    "```bash\n",
    "$ java Car.java\n",
    "0\n",
    "10\n",
    "```\n",
    "Δημιουργήστε νέα αρχεία ```Point.java, Line.java, Circle.java, Rectangle.java``` και αντιγράψτε τον κώδικα του προηγούμενου μαθήματος. Έχει σημασία η σειρά με την οποία θα μεταγλωττίσετε τον κώδικα. Οι κλάσεις ```Line, Circle``` και ```Rectangle``` εξαρτώνται από την ```Point```. Επομένως η ```Point``` πρέπει να μεταγλωττιστεί πρώτη. Καθώς δεν υπάρχει ```main()``` μέθοδος δεν υπάρχει νόημα να καλέσουμε την εντολή ```java``` για να τρέξουμε το πρόγραμμα.\n",
    "\n",
    "```bash\n",
    "$ javac Point.java\n",
    "$ javac Line.java\n",
    "$ javac Circle.java\n",
    "$ javac Rectangle.java\n",
    "$ ls\n",
    "Circle.class Circle.java Line.java Line.class Point.class Point.java Rectangle.class Rectangle.java\n",
    "```\n",
    "Συνηθίζεται αντί να έχουμε πολλά αρχεία ```.class```, να τα συλλέγουμε όλα μαζί σε ένα συμπιεσμένο αρχείο ```.jar``` (ή Java Archive). Π.χ. μπορούμε να φτιάξουμε μια βιβλιοθήκη των εγγραφών που δημιουργήσαμε πιο πάνω ως εξής.\n",
    "\n",
    "Μεταβείτε στο φάκελο που έχετε μεταγλωττίσει τον κώδικα, δηλ. στο φάκελο που περιέχει τα αρχεία ```.class``` και δώστε την εντολή:\n",
    "\n",
    "```bash\n",
    "$ jar cvf shapes.jar *.class   // ή jar -c -f shapes.jar *.class\n",
    "\n",
    "$ jar --help\n",
    "Usage: jar [OPTION...] [ [--release VERSION] [-C dir] files] ...\n",
    "jar creates an archive for classes and resources, and can manipulate or\n",
    "restore individual classes or resources from an archive.\n",
    "  ...\n",
    "  -c, --create               Create the archive\n",
    "  -i, --generate-index=FILE  Generate index information for the specified jar\n",
    "                             archives\n",
    "  -t, --list                 List the table of contents for the archive\n",
    "  -u, --update               Update an existing jar archive\n",
    "  -x, --extract              Extract named (or all) files from the archive\n",
    "  -d, --describe-module      Print the module descriptor, or automatic module name\n",
    "      --validate             Validate the contents of the jar archive. This option\n",
    "                             will validate that the API exported by a multi-release\n",
    "                             jar archive is consistent across all different release\n",
    "                             versions.\n",
    "  ...\n",
    "  \n",
    "$ jar tf shapes.jar   // ή jar -t -f shapes.jar\n",
    "META-INF/\n",
    "META-INF/MANIFEST.MF\n",
    "Circle.class\n",
    "Line.class\n",
    "Point.class\n",
    "Rectangle.class\n",
    "```\n",
    "Το αρχείο ```.jar``` είναι ένα ```.zip``` αρχείο μετονομασμένο σε ```.jar``` το οποίο περιέχει και ένα αρχείο ```MANIFEST.MF```:\n",
    "\n",
    "```bash\n",
    "$ unzip -p shapes.jar META-INF/MANIFEST.MF\n",
    "Manifest-Version: 1.0\n",
    "Created-By: 17 (Oracle Corporation)\n",
    "```\n",
    "Αν υπάρχει και μια 'εκτελέσιμη' κλάση στο έργο σας (δηλ. μια κλάση που περιέχει μια μέθοδο ```main()```) τότε μπορούμε να την δηλώσουμε στο ```MANIFEST.MF``` ως εξής:\n",
    "\n",
    "```bash\n",
    "$ jar cvfe cardemo.jar Car Car.class   // ή jar -c -f cardemo.jar -e Car Car.class\n",
    "\n",
    "$ unzip -p cardemo.jar META-INF/MANIFEST.MF\n",
    "Manifest-Version: 1.0\n",
    "Created-By: 17 (Oracle Corporation)\n",
    "Main-Class: Car\n",
    "\n",
    "$ java -jar cardemo.jar\n",
    "0\n",
    "10\n",
    "```\n",
    "Παρατηρούμε ότι δημιουργήσαμε έτσι ένα εκτελέσιμο ```.jar``` αρχείο το οποίο μπορούμε να το εκτελέσουμε με την τελευταία εντολή!"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b1e05cba-6135-4b71-9aec-3b890039d8fa",
   "metadata": {},
   "source": [
    "## BlueJ\n",
    "\n",
    "1. Δημιουργήστε ένα νέο έργο από το μενού **Project -> New Project**\n",
    "1. Κλικ στο κουμπί **New Class...**. Παρατηρούμε ότι το BlueJ υποστηρίζει τους τύπους 'Class'(Κλάση), 'Abstract Class' (Αφηρημένη Κλάση) που θα μάθουμε σε επόμενο μάθημα, 'Interface' (Διεπαφή), 'Unit Test' (Δοκιμασία Μονάδας, θα μάθουμε σε επόμενο μάθημα πώς να τεστάρουμε τις κλάσεις μας) 'Enum' (Απαριθμημένος Τύπος) και 'Record' (Εγγραφή).\n",
    "\n",
    "![](assets/Fig1.png)\n",
    "\n",
    "**Εικόνα 3.2.1** _Παράθυρο δημιουργίας νέας κλάσης στο BlueJ_\n",
    "\n",
    "3. Δώστε το όνομα ```Car``` και πατήστε **OK**. Δημιουργήθηκε ένα παραλληλόγραμμο με το όνομα _Car_. Αυτό είναι το σύμβολο της κλάσης στην UML. Θα μάθουμε για τη UML και πώς αναπαριστά κλάσεις, διεπαφές κλπ. στο επόμενο μάθημα.\n",
    "\n",
    "![](assets/Fig2.png)\n",
    "\n",
    "**Εικόνα 3.2.2** _Κλάση Car στο BlueJ_\n",
    "\n",
    "4. Πατήστε διπλό κλικ πάνω στην _Car_ για να ανοίξει ο κειμενογράφος ή διορθωτής του BlueJ.\n",
    "5. Επιλέξτε όλον τον κώδικα που έχει δημιουργήσει το BlueJ. Σβήστε τον και επικολλήστε τον κώδικα της κλάσης ```Car``` που γράψαμε στο προηγούμενο μάθημα.\n",
    "6. Μεταγλωττίστε την κλάση ```Car``` πατώντας στο κουμπί **Compile**.\n",
    "7. Για να δημιουργήσουμε ένα νέο αντικείμενο της κλάσης ```Car```, κάντε δεξί κλικ πάνω στο εικονίδιο της ```Car``` και επιλέξτε τον constructor της κλάσης.\n",
    "8. Δώστε τις παρακάτω τιμές στο διαλογικό παράθυρο που εμφανίζεται:\n",
    "\n",
    "![](assets/Fig3.png)\n",
    "\n",
    "**Εικόνα 3.2.3** _Δημιουργία νέου αντικειμένου κλάσης ```Car``` στο BlueJ_\n",
    "\n",
    "9. Δημιουργήθηκε ένα νέο αντικείμενο κλάσης ```Car``` στον πάγκο όπως φαίνεται στην παρακάτω εικόνα. Φυσικά μπορείτε να δημιουργήσετε όσα αντικείμενα θέλετε.\n",
    "\n",
    "![](assets/Fig4.png)\n",
    "\n",
    "**Εικόνα 3.2.4** _Δημιουργήθηκε το νέο αντικειμένο κλάσης ```Car``` στο BlueJ_\n",
    "\n",
    "10. Πατήστε δεξί κλικ στο νέο αντικείμενο και καλέστε τις διαθέσιμες μεθόδους του:\n",
    "\n",
    "![](assets/Fig5.png)\n",
    "\n",
    "**Εικόνα 3.2.5** _Κλήση της ```toString()``` αφού κλήθηκε πρώτα η ```accelerate()```_\n",
    "\n",
    "Παρατηρήστε ότι το BlueJ δεν σας επιτρέπει να προσπελάσετε τις ιδιότητες της κλάσης ```Car``` παρόλο που αυτές δεν είναι ```private```.\n",
    "\n",
    "Το BlueJ σας δίνει επίσης τη δυνατότητα να δημιουργήσετε αντικείμενα από κλάσεις που δεν είναι μέρος του έργου σας αλλά μέρος της βιβλιοθήκης της Java.\n",
    "\n",
    "Από το μενού **Tools –> Use Library Class...** θα εμφανιστεί ένα διαλογικό παράθυρο παροτρύνοντας σας να εισάγετε ένα πλήρως κατάλληλο όνομα κλάσης, όπως π.χ. ```java.lang.String```. Μόλις εισαχθεί ένα όνομα κλάσης, πατώντας **Enter** θα παρουσιάσει όλους τους κατασκευαστές και τις στατικές μεθόδους εκείνης της κλάσης σε έναν κατάλογο στο διαλογικό παράθυρο. Οποιοιδήποτε από αυτούς τους κατασκευαστές ή στατικές μεθόδους μπορούν να κληθούν επιλέγοντας τους από αυτόν τον κατάλογο. Η επίκληση (invocation) προχωρά όπως και με κάθε άλλο κατασκευαστή ή κλήση μεθόδου.\n",
    "\n",
    "Σαν άσκηση δημιουργήστε ένα αντικείμενο της ```java.util.Random```. Η ```Random``` είναι μια γεννήτρια τυχαίων αριθμών. Αφού δημιουργήσετε ένα αντικείμενο της κλάσης, στη συνέχεια κάντε δεξί κλικ πάνω του και καλέστε τη μέθοδο ```nextInt()```. Θα εμφανιστεί ένα διαλογικό παράθυρο με τον τυχαίο ακέραιο αριθμό που \"γέννησε\" η μέθοδος.\n",
    "\n",
    "Με το BlueJ μπορούμε πολύ εύκολα να δημιουργήσουμε ένα εκτελέσιμο ```.jar``` αρχείο ως εξής:\n",
    "\n",
    "1. Επιλέξτε το μενού **Project -> Create Jar File...** \n",
    "1. Από το αναδυόμενο παράθυρο επιλέξτε ως _Main class_ την κλάση που περιέχει την ```main()``` μέθοδο\n",
    "1. Αποεπιλέξτε τα τσεκαρισμένα πεδία _Include source_ και _Include Blue project files_ και πατήστε **Continue**. Θα εμφανιστεί ένα διαλογικό παράθυρο που θα σας ζητήσει το όνομα του ```.jar``` αρχείου που πρόκειται να δημιουργηθεί καθώς και τον φάκελο στον οποίο θέλετε να δημιουργηθεί και πατήστε **Save**."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "e482fe31-74b5-4ca4-967b-f85fc858d702",
   "metadata": {
    "tags": []
   },
   "source": [
    "## NetBeans\n",
    "\n",
    "1. Δημιουργήστε ένα νέο έργο ```CarDemo``` και ορίστε την κύρια κλάση ως ```Car``` στο 2ο βήμα του οδηγού (βλ. Εικόνα 2.6.2).\n",
    "1. Επικολλήστε τον κώδικα της υποενότητας \"Κειμενογράφος\" στην αρχή αυτού του μαθήματος.\n",
    "1. Εκτελέστε το πρόγραμμα πατώντας στο κουμπί **Run Project**\n",
    "\n",
    "Το NetBeans υποστηρίζει και εγγραφές. \n",
    "1. Δημιουργήστε ένα νέο έργο ```RecordDemo``` όπως μάθαμε στο μάθημα 2.6 της προηγούμενης εβδομάδας, χωρίς να επιλέξετε **Create Main Class** στο 2ο βήμα του οδηγού (βλ. Εικόνα 2.6.2).\n",
    "1. Κάντε δεξί κλικ στο έργο ```RecordDemo``` από το παράθυρο _Projects_ και επιλέξτε **New -> Other** από το αναδυόμενο μενού.\n",
    "1. Επιλέξτε _Java Record_ όπως φαίνεται στην παρακάτω εικόνα και **Next**.\n",
    "1. Δώστε το όνομα ```Point``` σαν όνομα της κλάσης και **Finish**.\n",
    "1. Τροποποιήστε τον κώδικα που δημιούργησε το NetBeans με τον παρακάτω:\n",
    "\n",
    "![](assets/Fig6.png)\n",
    "\n",
    "**Εικόνα 3.2.6** _Δημιουργία νέας κλάσης, εγγραφής κλπ. στο NetBeans_"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "id": "176dcefc-94e7-44be-b71e-a369fe8892e1",
   "metadata": {},
   "outputs": [],
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "9c4458bb-5ad3-4904-96a1-1704ac4d1ad5",
   "metadata": {},
   "outputs": [],
   "source": [
    "record Point(int x, int y) { }"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6cf57df9-ed92-4f3f-b2ae-447786d480a8",
   "metadata": {},
   "source": [
    "Επαναλάβετε τη διαδικασία για να δημιουργήσετε και τις υπόλοιπες εγγραφές του προηγούμενου μαθήματος."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "bcc18f41-b74c-4852-8641-207ea59b70fe",
   "metadata": {},
   "source": [
    "Για να δημιουργήσουμε ένα εκτελέσιμο ```.jar``` στο NetBeans:\n",
    "\n",
    "1. Κάντε δεξί κλικ στο έργο και επιλέξτε **Properties** από το αναδυόμενο μενού.\n",
    "1. Επιλέξτε την κατηγορία _Run_ και ορίστε την κλάση που περιέχει την μέθοδο ```main()``` στο πεδίο _Main Class_ (πατήστε το κουμπί **Browse**  για να την εντοπίσετε).\n",
    "1. Πατήστε **ΟΚ** για να κλείσετε το παράθυρο **Properties**.\n",
    "1. Πάλι δεξί κλικ στο έργο και επιλέξτε **Clean and Build**. \n",
    "\n",
    "Στο φάκελο του έργου δημιουργήθηκε ένας υποφάκελος ```dist``` μέσα στον οποίο έχει δημιουργηθεί το εκτελέσιμο αρχείο ```.jar```. Μπορείτε να το δείτε και από την καρτέλα ```Files``` του NetBeans."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d9c0ebc7-0e4b-4dfc-af61-244746337c47",
   "metadata": {},
   "source": [
    "## Visual Studio Code\n",
    "1. Δημιουργήστε ένα νέο φάκελο στο Λ.Σ. σας με όνομα ```CarDemo```.\n",
    "1. Επιλέξτε το μενού **File -> Add Folder to Workspace...** και προσθέστε το φάκελο ```CarDemo``` στον ήδη ανοικτό χώρο εργασίας (workspace).\n",
    "1. Δημιουργήστε ένα νέο έργο Java όπως μάθαμε στην ενότητα 2.6. Το VS Code δημιούργησε και ένα αρχείο ```App.java``` το οποίο περιέχει μια ```main()``` μέθοδο.\n",
    "1. Επιλέξτε όλα τα περιεχόμενα του αρχείου, διαγράψτε τα και επικολλήστε τον κώδικα της κλάσης ```Car``` στην αρχή αυτού του μαθήματος και αποθηκεύστε τις αλλαγές.\n",
    "1. Μετονομάστε το αρχείο ```App.java``` σε ```Car.java``` πατώντας δεξί κλικ πάνω του στο χώρο εργασίας (βρίσκεται μέσα στο φάκελο ```src```) και επιλέγοντας ```Rename``` από το αναδυόμενο μενού.\n",
    "1. Κάντε πάλι δεξί κλικ πάνω του και αυτή τη φορά επιλέξτε ```Run Java``` από το αναδυόμενο μενού. Θα πρέπει να δείτε την ταχύτητα του αυτοκινήτου, δηλ. ```0``` και ```10```.\n",
    "1. Επιλέξτε το φάκελο ```src``` και στη συνέχεια κλικ στο μενού **File -> New File...**.\n",
    "1. Γράψτε ```java``` και επιλέξτε **New java class**.\n",
    "1. Επικολλήστε τον παρακάτω κώδικα σβήνοντας ότι έχει δημιουργήσει το VS Code.\n",
    "1. Αποθηκεύστε το αρχείο ως ```Point.java```\n",
    "1. Επιλέξτε το μενού **View -> Command palette...** και πληκτρολογήστε ```Java Compile``` για να μεταγλωττίσετε τις κλάσεις."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "id": "5f4b6c3e-dff0-4d11-b1f9-4e9592481621",
   "metadata": {},
   "outputs": [],
   "source": [
    "record Point(int x, int y) { }"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "25336362-56d4-4b59-b251-b56e225c94ea",
   "metadata": {},
   "source": [
    "Η διαδικασία δημιουργίας εκτελέσιμου αρχείου ```.jar``` περιγράφεται [εδώ](https://dev.to/rohitk570/create-an-executable-jar-file-on-vs-code-n-command-line-154b).\n",
    "\n",
    "1. Μεταγλωττίστε τον πηγαίο κώδικα.\n",
    "1. Στην επιλογή _JAVA PROJECTS_ κάτω αριστερά πατήστε στο κουμπί **Export Jar...** (σύμβολο ```|->```). \n",
    "1. Στο πλαίσιο που θα εμφανιστεί δώστε το όνομα της κλάσης που περιέχει την μέθοδο ```main()``` και θα δημιουργηθεί το εκτελέσιμο αρχείο JAR στο φάκελο του έργου σας."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "109df8d5-89d8-44fa-9cd2-be9decdba61a",
   "metadata": {},
   "source": [
    "\n",
    "---\n",
    "\n",
    "[<](../3.1-OOP/3.1-OOP.ipynb) | [Δ](../../TOC.ipynb) | [>](../3.3-UML/3.3-UML.ipynb)\n",
    "\n",
    "---"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Java",
   "language": "java",
   "name": "java"
  },
  "language_info": {
   "codemirror_mode": "java",
   "file_extension": ".jshell",
   "mimetype": "text/x-java-source",
   "name": "Java",
   "pygments_lexer": "java",
   "version": "17+35-LTS-2724"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
